﻿/* usccmd class for AutoHotkey_L 1.1.00.00 or newer.

Copyright (c) 2011 Bryan Perry

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

--------------------------------------------------------------
Basic usage:
--------------------------------------------------------------
#Include usccmd.ahk
u := new usccmd()
MsgBox, % u.list()

^!c::
u.accel(0, 12)
u.speed(0, 12)
u.servo(0, 7500)
return

^!b::
u.program("program1.txt")
u.start()
return

--------------------------------------------------------------
Controlling multiple devices:
--------------------------------------------------------------
#Include usccmd.ahk
u1 := new usccmd("00001430")

;~ or alternatively:
u2 := new usccmd()
u2.device := "00001431"

^!a::
u1.servo(0, 7500)
u2.servo(0, 4500)
return

--------------------------------------------------------------
Specifying the path to usccmd if it's not in your system path:
--------------------------------------------------------------
#Include usccmd.ahk
u1 := new usccmd("", "C:\path\with\trailing\slash\")

;~ or alternatively:
u2 := new usccmd()
u2.path := "C:\path\with\trailing\slash\"
--------------------------------------------------------------
*/

#NoEnv

class usccmd {
	__New(device = "", path = "") {
		this.device := device
		this.path := path
	}

	__Call(cmd, p1 = "", p2 = "") {
		RunWait, % comspec . " /c """ . this.path . "usccmd" . (this.device ? " --device " . this.device : "") . " --" . cmd 	. " """ . p1 . (p2 != "" ? "," . p2 : "") . """"" > usccmd_output.tmp",, Hide
		FileRead, output, usccmd_output.tmp
		FileDelete, usccmd_output.tmp
		return, output
	}
}